/**
 * WEBLAB: Service oriented integration platform for media mining and intelligence applications
 * 
 * Copyright (C) 2004 - 2011 CASSIDIAN
 * 
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */

package org.ow2.weblab.core.extended.jaxbe.test;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Map;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;

import org.ow2.weblab.core.model.Resource;


/**
 *
 */
public class DummyResource extends Resource {


	private static final long serialVersionUID = 121L;

	/**
	 * 
	 */
	public static int result = 0;

	/**
	 * @param classes
	 *            The classes of the context
	 * @param properties
	 *            The properties of the context
	 * @return The context
	 * @throws IllegalAccessException
	 *             ??
	 * @throws ClassNotFoundException
	 *             ??
	 * @throws SecurityException
	 *             ??
	 * @throws NoSuchMethodException
	 *             ??
	 * @throws IllegalArgumentException
	 *             ??
	 * @throws InvocationTargetException
	 *             ??
	 * 
	 */
	public static Object createContext(final Class<?>[] classes, final Map<?, ?> properties) throws IllegalAccessException, ClassNotFoundException,
			SecurityException, NoSuchMethodException, IllegalArgumentException, InvocationTargetException {
		if (DummyResource.result == 1) {
			throw new IllegalAccessException("for testing purposes");
		} else if (DummyResource.result == 0) {
			final Class<?> clazz = ClassLoader.getSystemClassLoader().loadClass("com.sun.xml.internal.bind.v2.ContextFactory");
			final Method m = clazz.getMethod("createContext", Class[].class, Map.class);
			return m.invoke(null, classes, properties);
		} else if (DummyResource.result == 2) {
			return new JAXBContext() {

				@Override
				public Validator createValidator() throws JAXBException {
					throw new JAXBException("testing ...");
				}

				@Override
				public Unmarshaller createUnmarshaller() throws JAXBException {
					throw new JAXBException("testing ...");
				}

				@Override
				public Marshaller createMarshaller() throws JAXBException {
					throw new JAXBException("testing ...");
				}
			};
		} else if ((DummyResource.result == 3) || (DummyResource.result == 5)) {
			return new JAXBContext() {

				@Override
				public Validator createValidator() throws JAXBException {
					throw new JAXBException("testing ...");
				}

				@Override
				public Unmarshaller createUnmarshaller() throws JAXBException {
					throw new JAXBException("testing ...");
				}

				@Override
				public Marshaller createMarshaller() throws JAXBException {
					return new DummyMarchaller(DummyResource.result);
				}
			};

		} else if (DummyResource.result == 4) {
			return new JAXBContext() {

				@Override
				public Validator createValidator() throws JAXBException {
					throw new JAXBException("testing ...");
				}

				@Override
				public Unmarshaller createUnmarshaller() throws JAXBException {
					return new DummyUnmarchaller();
				}

				@Override
				public Marshaller createMarshaller() throws JAXBException {
					throw new JAXBException("testing ...");
				}
			};

		}
		return null;
	}

}
