/**
 * WEBLAB: Service oriented integration platform for media mining and intelligence applications
 * 
 * Copyright (C) 2004 - 2011 Cassidian, an EADS company
 * 
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
package org.ow2.weblab.core.extended.ontologies;

import java.lang.reflect.InvocationTargetException;

import junit.framework.Assert;

import org.junit.Test;
import org.ow2.weblab.core.extended.exception.WebLabUncheckedException;
import org.ow2.weblab.core.model.Document;


/**
 */
@Deprecated
public class TestWebLabOnto {

	/**
	 * 
	 */
	@Test
	public void testConstructor() {
		try {
			TestOntology.constructorCall(WebLab.class);
			Assert.fail();
		} catch (final InvocationTargetException ite) {
			// Normal
		}
	}


	/**
	 * 
	 */
	@Test
	public void testWebLabOnto() {
		final String uriDoc = WebLab.getUriFromClass(Document.class);
		Assert.assertEquals("http://weblab.ow2.org/core/1.2/ontology/model#Document", uriDoc);
		final Class<?> classDoc = WebLab.getClassFromUri(uriDoc);
		Assert.assertNotNull(classDoc);
		Assert.assertEquals("org.ow2.weblab.core.model.Document", classDoc.getName());

		try {
			WebLab.getClassFromUri(null);
			Assert.fail();
		} catch (final WebLabUncheckedException w) {
			// Normal
		}
		try {
			WebLab.getClassFromUri("");
			Assert.fail();
		} catch (final WebLabUncheckedException w) {
			// Normal
		}
		try {
			WebLab.getClassFromUri("weblab://blablablablabllab");
			Assert.fail();
		} catch (final WebLabUncheckedException w) {
			// Normal
		}
		try {
			WebLab.getClassFromUri("http://weblab.ow2.org/1.2/model/class#Toto");
			Assert.fail();
		} catch (final WebLabUncheckedException w) {
			// Normal
		}
		try {
			WebLab.getClassFromUri("http://weblab.ow2.org/core/1.2/ontology/model#Coordinate");
			Assert.fail();
		} catch (final ClassCastException cce) {
			// Normal
		}
		try {
			WebLab.getClassFromUri("http://weblab.ow2.org/core/1.2/ontology/model#Unkown");
			Assert.fail();
		} catch (final ClassCastException cce) {
			// Normal
		}
	}

}
