/**
 * WEBLAB: Service oriented integration platform for media mining and intelligence applications
 *  
 * Copyright (C) 2004 - 2011 Cassidian, an EADS company
 * 
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
package org.ow2.weblab.core.helper.impl;

import java.io.File;
import java.io.FileNotFoundException;

import junit.framework.Assert;
import junit.framework.TestCase;

import org.ow2.weblab.core.extended.exception.WebLabCheckedException;
import org.ow2.weblab.core.extended.jaxb.WebLabMarshaller;
import org.ow2.weblab.core.extended.ontologies.RDF;
import org.ow2.weblab.core.model.ComposedResource;

public class Multiligne extends TestCase {


	public void testMultiLignes() throws WebLabCheckedException, FileNotFoundException {
		final AdvancedSelector s = RDFSelectorFactory.getSelector(true);
		final ComposedResource rc = new WebLabMarshaller().unmarshal(new File("src/test/resources/composedResource.xml"), ComposedResource.class);
		final Statements wm = s.searchFor(rc, RDF.TYPE, "http://purl.org/dc/elements/1.1/format", "http://purl.org/dc/elements/1.1/author");
		Assert.assertEquals(1, wm.size());
	}
}
