/**
 * WEBLAB: Service oriented integration platform for media mining and intelligence applications
 *  
 * Copyright (C) 2004 - 2011 Cassidian, an EADS company
 * 
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
package org.ow2.weblab.core.helper.impl;

import java.io.File;
import java.util.List;

import junit.framework.TestCase;

import org.ow2.weblab.core.extended.exception.WebLabCheckedException;
import org.ow2.weblab.core.extended.jaxb.WebLabMarshaller;
import org.ow2.weblab.core.extended.ontologies.RDF;
import org.ow2.weblab.core.model.Document;

public class SelectionPerfTest extends TestCase {


	private static Document doc = SelectionPerfTest.loadDoc();


	private static Document loadDoc() {
		try {
			return new WebLabMarshaller().unmarshal(new File("src/test/resources/document.xml"), Document.class);
		} catch (final WebLabCheckedException e) {
			e.printStackTrace();
		}
		return null;
	}


	public void testSimpleSelection() throws WebLabCheckedException {
		final long time = System.currentTimeMillis();
		final TripleSelectors ts = new TripleSelectors(true);
		final List<WTriple> l = ts.findInResource(SelectionPerfTest.doc, null, RDF.TYPE, null);
	}


	public void testSimpleCSelection() throws WebLabCheckedException {
		final long time = System.currentTimeMillis();
		final ComplexTripleSelector cts = new ComplexTripleSelector();
		cts.supportNullData = true;
		final List<WTriple> l = cts.findInResource(SelectionPerfTest.doc, null, RDF.TYPE, null);
	}

	// public void testFilteredSelection() throws WebLabCheckedException{
	// long time = System.currentTimeMillis();
	// TripleSelectors ts = new TripleSelectors(true);
	// List<WTriple> l = ts.findInResource(doc, null, RDF.TYPE, null);
	// l.addAll(ts.findInResource(doc, null, "http://weblab-project.org/property/temis/endDate", null));
	// l.addAll(ts.findInResource(doc, null, "http://weblab-project.org/property/temis/date", null));
	// }
	//
	// public void testFilteredCSelection() throws WebLabCheckedException{
	// long time = System.currentTimeMillis();
	// ComplexTripleSelector cts = new ComplexTripleSelector();
	// cts.supportNullData = true;
	// cts.addPORule(RDF.TYPE, ".*");
	// cts.addPORule("http://weblab-project.org/property/temis/startDate", ".*");
	// cts.addPORule("http://weblab-project.org/property/temis/date", ".*");
	// }
}
