/**
 * WEBLAB: Service oriented integration platform for media mining and intelligence applications
 *  
 * Copyright (C) 2004 - 2011 Cassidian, an EADS company
 * 
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
package org.ow2.weblab.core.helper.impl.parser;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class ReflectChanger {


	public static void setSystemClassLoader(final ClassLoader cl) {
		ReflectChanger.setField(null, ClassLoader.class, "scl", cl, true);
	}


	public static <T> void setField(final T object, final Class<? extends T> clazz, final String fieldName, final Object value, final boolean declared) {
		try {
			final Field f = declared ? clazz.getDeclaredField(fieldName) : clazz.getField(fieldName);
			f.setAccessible(true);
			f.set(object, value);
		} catch (final SecurityException e1) {
			e1.printStackTrace();
		} catch (final NoSuchFieldException e1) {
			e1.printStackTrace();
		} catch (final IllegalArgumentException e) {
			e.printStackTrace();
		} catch (final IllegalAccessException e) {
			e.printStackTrace();
		}
	}


	public static <T> Object invoke(final T object, final Class<? extends T> clazz, final String methodName, final boolean declared, final Object[] args,
			final Class<?>... params) {
		try {
			final Method m = declared ? clazz.getDeclaredMethod(methodName, params) : clazz.getMethod(methodName, params);
			m.setAccessible(true);
			final Object result = m.invoke(object, args);
			return result;
		} catch (final SecurityException e1) {
			e1.printStackTrace();
		} catch (final NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (final IllegalArgumentException e) {
			e.printStackTrace();
		} catch (final IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (final InvocationTargetException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
}
