/**
 * WEBLAB: Service oriented integration platform for media mining and intelligence applications
 *  
 * Copyright (C) 2004 - 2011 Cassidian, an EADS company
 * 
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
package org.ow2.weblab.core.helper.test;

import java.io.File;
import java.util.List;

import org.ow2.weblab.core.extended.exception.WebLabCheckedException;
import org.ow2.weblab.core.extended.jaxb.WebLabMarshaller;
import org.ow2.weblab.core.helper.impl.AdvancedSelector;
import org.ow2.weblab.core.helper.impl.RDFSelectorFactory;
import org.ow2.weblab.core.helper.impl.Statements;
import org.ow2.weblab.core.helper.impl.WTriple;
import org.ow2.weblab.core.helper.impl.parser.RDFDateTypeParser;
import org.ow2.weblab.core.model.Annotation;
import org.ow2.weblab.core.model.ComposedResource;



public class BugTester {


	public static void main(final String[] args) {

		System.out.println(RDFDateTypeParser.class.getCanonicalName());

		try {
			final ComposedResource resource = new WebLabMarshaller().unmarshal(new File("src/test/resources/bugfix/test.xml"), ComposedResource.class);
			final Annotation annotation = new Annotation();

			final AdvancedSelector selector = RDFSelectorFactory.getSelector(true);
			final Statements s = selector.searchFor(resource);
			selector.searchFor(annotation, "weblab://property/test");
			final List<WTriple> lw = selector.findInResource(resource, null, null, null, true);
			System.out.println(s);
			System.out.println(lw);


		} catch (final WebLabCheckedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}



		// Resource resultset = new WebLabMarshaler().unmarshal(new File("src/test/resources/bugfix/pokbugarabe.xml"), Resource.class);
		// String[] list1 = new String[]{
		// "http://weblab-project.org/core/model/property/processing/hasNativeContent",
		// "http://weblab-project.org/core/model/property/processing/hasNormalisedContent",
		// "http://weblab-project.org/core/model/property/processing/isGeneratedFrom",
		// "http://weblab-project.org/core/model/property/processing/isProducedFrom",
		// "http://weblab-project.org/core/model/property/processing/isExposedAs" ,
		// "http://weblab-project.org/core/model/property/processing/hasGatheringDate" ,
		// "http://weblab-project.org/core/model/property/crawler/projectName" ,
		// "http://weblab-project.org/core/model/property/processing/hasOriginalFileSize" ,
		// "http://weblab-project.org/core/model/property/processing/hasOriginalFileName" ,
		// "http://weblab-project.org/core/model/property/processing/refersTo" };
		//
		//
		// String[] list2 = new String[]{
		// "http://purl.org/dc/elements/1.1/title" ,
		// "http://purl.org/dc/elements/1.1/creator" ,
		// "http://purl.org/dc/elements/1.1/subject" ,
		// "http://purl.org/dc/elements/1.1/description" ,
		// "http://purl.org/dc/elements/1.1/publisher" ,
		// "http://purl.org/dc/elements/1.1/contibutor" ,
		// "http://purl.org/dc/elements/1.1/date" ,
		// "http://purl.org/dc/elements/1.1/type" ,
		// "http://purl.org/dc/elements/1.1/format" ,
		// "http://purl.org/dc/elements/1.1/identifier" ,
		// "http://purl.org/dc/elements/1.1/source" ,
		// "http://purl.org/dc/elements/1.1/language" ,
		// "http://purl.org/dc/elements/1.1/relation" ,
		// "http://purl.org/dc/elements/1.1/coverage" ,
		// "http://purl.org/dc/elements/1.1/right" ,
		// "http://purl.org/dc/terms/modified" ,
		// "http://purl.org/dc/terms/created" ,
		// "http://purl.org/dc/terms/extent" ,
		//
		//
		// "http://xmlns.com/foaf/0.1/thumbnail",
		// "http://xmlns.com/foaf/0.1/firstName",
		// "http://xmlns.com/foaf/0.1/lastName",
		//
		//
		// "http://www.w3.org/2000/01/rdf-schema#seeAlso" ,
		//
		//
		// "http://weblab-project.org/core/model/property/retrieval/isResultOf" ,
		// "http://weblab-project.org/core/model/property/retrieval/hasNumberOfResults" ,
		// "http://weblab-project.org/core/model/property/retrieval/hasQueryOffset" ,
		// "http://www.w3.org/1999/02/22-rdf-syntax-ns#type" ,
		// "http://weblab-project.org/core/model/class/retrieval/Hit" ,
		//
		//
		// "http://weblab-project.org/core/model/property/retrieval/hasRank" ,
		// "http://weblab-project.org/core/model/property/retrieval/hasDescription" ,
		// "http://weblab-project.org/core/model/property/retrieval/hasScore" ,
		// "http://weblab-project.org/core/model/property/retrieval/isLinkedTo" ,
		// "http://weblab-project.org/core/model/property/retrieval/inResultSet" };
		//
		//
		// AdvancedSelector selector = RDFSelectorFactory.getSelector(true);
		// Statements sts = selector.searchFor(resultset,list2);
		//
		// // List<WTriple> l = selector.findInResource(resultset,null,null,null,true);
		// // Statements s = new Statements();
		// // s.addAll(l);
		// // System.out.println(s);
		//
		// System.out.println(sts);


	}
}
