package org.ow2.weblab.core.helper.test;

import java.io.File;
import java.net.URI;
import java.util.Date;

import org.ow2.weblab.core.extended.exception.WebLabCheckedException;
import org.ow2.weblab.core.extended.factory.ResourceFactory;
import org.ow2.weblab.core.extended.jaxb.WebLabMarshaller;
import org.ow2.weblab.core.model.Annotation;
import org.ow2.weblab.core.model.ComposedResource;
import org.ow2.weblab.core.model.Document;
import org.ow2.weblab.core.model.ResultSet;
import org.ow2.weblab.core.model.processing.WProcessingAnnotator;

public class ResourcesCreator {
	
	public static void buildTestResources() {

		final File ano = new File("src/test/resources/annotation.xml");
		final File doc = new File("src/test/resources/document.xml");
		final File rs = new File("src/test/resources/resultSet.xml");
		final File cp = new File("src/test/resources/composedResource.xml");

		final Document document = ResourceFactory.createResource("i", "doc", Document.class);
		final WProcessingAnnotator wp1 = new WProcessingAnnotator(document);
		wp1.writeType(URI.create("Document"));
		wp1.writeLabel("Document2");


		wp1.startInnerAnnotatorOn(URI.create("empty"));
		// wp1.writeType(URI.create("empty"));
		for (int i = 0; i < 45; i++) {
			wp1.writeLabel("empty" + i);
		}

		final Annotation annotation2 = new Annotation();
		annotation2.setUri("empty");
		final WProcessingAnnotator wp2 = new WProcessingAnnotator(URI.create("empty"), annotation2);
		wp2.writeGatheringDate(new Date());
		wp2.startSpecifyLanguage("fr");
		wp2.writeLabel("empty");

		final ResultSet resultSet = ResourceFactory.createResource("res", "set", ResultSet.class);
		resultSet.setPok(annotation2);

		final ComposedResource composedResource = ResourceFactory.createResource("c", "p", ComposedResource.class);
		composedResource.getResource().add(resultSet);
		composedResource.getResource().add(document);

		final WebLabMarshaller marshaller = new WebLabMarshaller();
		try {
			marshaller.marshalResource(annotation2, ano);
			marshaller.marshalResource(document, doc);
			marshaller.marshalResource(resultSet, rs);
			marshaller.marshalResource(composedResource, cp);

		} catch (final WebLabCheckedException e) {
			e.printStackTrace();
		}

	}
	
}
