/**
 * WEBLAB: Service oriented integration platform for media mining and intelligence applications
 * 
 * Copyright (C) 2004 - 2011 CASSIDIAN
 * 
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */

package org.ow2.weblab.core.helper.impl;

import java.io.File;
import java.util.List;
import java.util.Set;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;
import org.ow2.weblab.core.extended.jaxb.WebLabMarshaller;
import org.ow2.weblab.core.model.Resource;
import org.ow2.weblab.utils.RDFHelperException;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.SimpleSelector;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;

/**
 */
@Deprecated
public class JenaResourceHelperExtendedTest {


	private static final String RDFXML = "<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" "
			+ "       xmlns:VCARD='http://www.w3.org/2001/VCARD-rdf/3.0#'" + "       xmlns:cat=\"http://nowhere/else#\""
			+ "	      xmlns:nsA=\"http://somewhere/else#\"" + "       xmlns:test=\"weblab://reifyingProperty#\">"
			+ "			<rdf:Description rdf:about=\"weblab://myStatementUri#1\">" + "				<rdf:subject rdf:resource=\"weblab://mySubjectUri#1\" />"
			+ "				<rdf:predicate rdf:resource=\"http://myPredicateUri.org/aa#a1\" />" + "				<rdf:object rdf:resource=\"weblab://myObjectUri#1\" />"
			+ "				<rdf:type rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Statement\" />"
			+ "				<test:test rdf:resource=\"weblab://testValue1\" />" + "				<test:test rdf:resource=\"weblab://testValue11\" />"
			+ "				<test:test1>Another dirty object 1</test:test1>" + "			</rdf:Description>" + "			<rdf:Description rdf:about=\"weblab://myStatementUri#2\">"
			+ "				<rdf:subject rdf:resource=\"weblab://mySubjectUri#2\" />" + "				<rdf:predicate rdf:resource=\"http://myPredicateUri.org/aa#a2\" />"
			+ "				<rdf:object>My object number 2</rdf:object>" + "				<rdf:type rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Statement\" />"
			+ "			</rdf:Description>" + "			<rdf:Description rdf:nodeID=\"Node3\">" + "				<rdf:subject rdf:resource=\"weblab://mySubjectUri#3\" />"
			+ "				<rdf:predicate rdf:resource=\"http://myPredicateUri.org/aa#a3\" />" + "				<rdf:object rdf:resource=\"weblab://myObjectUri#3\" />"
			+ "				<rdf:type rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Statement\" />" + "			</rdf:Description>"
			+ "			<rdf:Description rdf:nodeID=\"Node4\">" + "				<rdf:subject rdf:resource=\"weblab://mySubjectUri#4\" />"
			+ "				<rdf:predicate rdf:resource=\"http://myPredicateUri.org/aa#a4\" />" + "				<rdf:object>My object number 4</rdf:object>"
			+ "				<rdf:type rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Statement\" />"
			+ "				<test:test rdf:resource=\"weblab://testValue4\" />" + "			</rdf:Description>"
			+ "	         <rdf:Description rdf:about=\"http://somewhere/else#root\">" + "		         <nsA:P rdf:resource=\"http://somewhere/else#x\"/>"
			+ "		         <nsA:P rdf:resource=\"http://somewhere/else#y\"/>" + "		     </rdf:Description>"
			+ "		     <rdf:Description rdf:about=\"http://somewhere/else#y\">" + "		         <cat:Q rdf:resource=\"http://somewhere/else#z\"/>"
			+ "		     </rdf:Description>" + "<rdf:Description rdf:nodeID=\"A0\">" + "    <VCARD:Family>Smith</VCARD:Family>"
			+ "    <VCARD:Given>John</VCARD:Given>" + "  </rdf:Description>" + "  <rdf:Description rdf:about='http://somewhere/JohnSmith/'>"
			+ "    <VCARD:FN>John Smith</VCARD:FN>" + "    <VCARD:FN>Johnny Smith</VCARD:FN>" + "    <VCARD:N rdf:nodeID=\"A0\"/>" + "	</rdf:Description>"
			+ "	<rdf:Description rdf:about='http://somewhere/SarahJones/'>" + "	<VCARD:FN>Sarah Jones</VCARD:FN>" + "    <VCARD:N rdf:nodeID=\"A1\"/>"
			+ "  </rdf:Description>" + "  <rdf:Description rdf:about='http://somewhere/MattJones/'>" + "    <VCARD:FN>Matt Jones</VCARD:FN>"
			+ "    <VCARD:N rdf:nodeID=\"A2\"/>" + "  </rdf:Description>" + "  <rdf:Description rdf:nodeID=\"A3\">" + "    <VCARD:Family>Smith</VCARD:Family>"
			+ "    <VCARD:Given>Rebecca</VCARD:Given>" + "  </rdf:Description>" + "  <rdf:Description rdf:nodeID=\"A1\">"
			+ "    <VCARD:Family>Jones</VCARD:Family>" + "    <VCARD:Given>Sarah</VCARD:Given>" + "  </rdf:Description>"
			+ "  <rdf:Description rdf:nodeID=\"A2\">" + "    <VCARD:Family>Jones</VCARD:Family>" + "    <VCARD:Given>Matthew</VCARD:Given>"
			+ "  </rdf:Description>  <rdf:Description rdf:about='http://somewhere/RebeccaSmith/'>" + "    <VCARD:FN>Becky Smith</VCARD:FN>"
			+ "    <VCARD:N rdf:nodeID=\"A3\"/>" + "  </rdf:Description>" + "	     </rdf:RDF>";


	private JenaResourceHelperExtended helper;


	private Model m;


	// private Resource res;

	private Resource res2;


	private final static String VCARD = "http://www.w3.org/2001/VCARD-rdf/3.0#";


	private final static String SUBJ = "http://somewhere/else#root";


	private final static String PREDICATENSAP = "http://somewhere/else#P";


	private final static String JOHNSMITH = "http://somewhere/JohnSmith/";


	private final static String VCARDFNAME = JenaResourceHelperExtendedTest.VCARD + "FN";


	// private final String vcardName = this.vcard + "N";

	@Before
	public void setUp() throws Exception {
		this.helper = new JenaResourceHelperExtended();
		this.res2 = new WebLabMarshaller().unmarshal(new File("src/test/resources/res.xml"), Resource.class);
		this.helper.setResource(this.res2);
		this.helper.loadFromRdfXml(JenaResourceHelperExtendedTest.RDFXML);
		this.m = this.helper.bejh.getModel();
	}


	/**
	 * 
	 */
	@Test
	public void testSimpleResourceAccess() {
		this.helper.getResource();
	}


	/**
	 * test statement listing
	 */
	@Test
	public void testGetPredsOnSubj() {

		final StmtIterator it = this.m.listStatements(new SimpleSelector(null, null, (RDFNode) null) {


			@Override
			public boolean selects(final Statement s) {
				return ((s.getSubject() != null) && (s.getSubject().getURI() != null) && (s.getSubject().getURI()
						.compareTo(JenaResourceHelperExtendedTest.SUBJ) == 0));
			}
		});
		Set<String> preds = this.helper.getPredsOnSubj(JenaResourceHelperExtendedTest.SUBJ);

		while (it.hasNext()) {
			Assert.assertTrue(preds.contains(it.next().getPredicate().getURI()));
		}

		preds = this.helper.getPredsOnSubj(JenaResourceHelperExtendedTest.SUBJ + "toto");
		while (it.hasNext()) {
			Assert.assertFalse(preds.contains((it.next()).getPredicate().getURI()));
		}

		try {
			this.helper.getPredsOnSubj(null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
	}


	/**
	 * 
	 */
	@Test
	public void testGetLitsOnPredSubj() {
		final List<String> values = this.helper.getLitsOnPredSubj(JenaResourceHelperExtendedTest.JOHNSMITH, JenaResourceHelperExtendedTest.VCARDFNAME);

		final StmtIterator it = this.m.listStatements(new SimpleSelector(null, null, (RDFNode) null) {


			@Override
			public boolean selects(final Statement s) {
				return ((s.getSubject() != null) && (s.getSubject().getURI() != null) && (s.getSubject().getURI()
						.compareTo(JenaResourceHelperExtendedTest.JOHNSMITH) == 0))
						&& ((s.getPredicate() != null) && (s.getPredicate().getURI().compareTo(JenaResourceHelperExtendedTest.VCARDFNAME) == 0));
			}
		});

		Assert.assertEquals(it.toList().size(), values.size());

		while (it.hasNext()) {
			boolean ok = false;
			for (final String value : values) {
				if (value.compareTo(it.nextStatement().getString()) == 0) {
					ok = true;
				}
			}
			if (!ok) {
				Assert.fail();
			}
		}

		try {
			this.helper.getLitsOnPredSubj(null, JenaResourceHelperExtendedTest.VCARDFNAME);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.getLitsOnPredSubj(JenaResourceHelperExtendedTest.JOHNSMITH, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.getLitsOnPredSubj(null, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
	}


	/**
	 * 
	 */
	@Test
	public void testGetRessOnPredSubj() {
		final List<String> values = this.helper.getRessOnPredSubj(JenaResourceHelperExtendedTest.SUBJ, JenaResourceHelperExtendedTest.PREDICATENSAP);

		final StmtIterator it = this.m.listStatements(new SimpleSelector(null, null, (RDFNode) null) {


			@Override
			public boolean selects(final Statement s) {
				return ((s.getSubject() != null) && (s.getSubject().getURI() != null) && (s.getSubject().getURI()
						.compareTo(JenaResourceHelperExtendedTest.SUBJ) == 0))
						&& ((s.getPredicate() != null) && (s.getPredicate().getURI().compareTo(JenaResourceHelperExtendedTest.PREDICATENSAP) == 0));
			}
		});

		Assert.assertEquals(it.toList().size(), values.size());

		while (it.hasNext()) {
			boolean ok = false;
			for (final String value : values) {
				if (value.compareTo(((com.hp.hpl.jena.rdf.model.Resource) it.nextStatement().getObject()).getURI()) == 0) {
					ok = true;
				}
			}
			if (!ok) {
				Assert.fail();
			}
		}

		try {
			this.helper.getRessOnPredSubj(null, JenaResourceHelperExtendedTest.PREDICATENSAP);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.getRessOnPredSubj(JenaResourceHelperExtendedTest.SUBJ, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.getRessOnPredSubj(null, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
	}


	/**
	 * 
	 */
	@Test
	public void testHasLitStat() {
		Assert.assertTrue(this.helper.hasLitStat(JenaResourceHelperExtendedTest.JOHNSMITH, JenaResourceHelperExtendedTest.VCARDFNAME, "John Smith"));
		Assert.assertTrue(this.helper.hasLitStat(JenaResourceHelperExtendedTest.JOHNSMITH, JenaResourceHelperExtendedTest.VCARDFNAME, "Johnny Smith"));
		Assert.assertFalse(this.helper.hasLitStat(JenaResourceHelperExtendedTest.JOHNSMITH, JenaResourceHelperExtendedTest.VCARDFNAME,
				"Johnny Hooker from the bayou"));
		try {
			this.helper.hasLitStat(JenaResourceHelperExtendedTest.JOHNSMITH, JenaResourceHelperExtendedTest.VCARDFNAME, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasLitStat(JenaResourceHelperExtendedTest.JOHNSMITH, null, "John Smith");
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasLitStat(JenaResourceHelperExtendedTest.JOHNSMITH, null, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasLitStat(null, JenaResourceHelperExtendedTest.VCARDFNAME, "John Smith");
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasLitStat(null, JenaResourceHelperExtendedTest.VCARDFNAME, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasLitStat(null, null, "John Smith");
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasLitStat(null, null, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
	}


	/**
	 * 
	 */
	@Test
	public void testHasResStat() {
		Assert.assertTrue(this.helper.hasResStat(JenaResourceHelperExtendedTest.SUBJ, JenaResourceHelperExtendedTest.PREDICATENSAP, "http://somewhere/else#x"));
		Assert.assertTrue(this.helper.hasResStat(JenaResourceHelperExtendedTest.SUBJ, JenaResourceHelperExtendedTest.PREDICATENSAP, "http://somewhere/else#y"));
		Assert.assertFalse(this.helper.hasResStat(JenaResourceHelperExtendedTest.SUBJ, JenaResourceHelperExtendedTest.PREDICATENSAP, "http://somewhere/else#z"));
		try {
			this.helper.hasResStat(JenaResourceHelperExtendedTest.JOHNSMITH, JenaResourceHelperExtendedTest.VCARDFNAME, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasResStat(JenaResourceHelperExtendedTest.JOHNSMITH, null, "John Smith");
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasResStat(JenaResourceHelperExtendedTest.JOHNSMITH, null, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasResStat(null, JenaResourceHelperExtendedTest.VCARDFNAME, "John Smith");
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasResStat(null, JenaResourceHelperExtendedTest.VCARDFNAME, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasResStat(null, null, "John Smith");
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.hasResStat(null, null, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
	}


	/**
	 * 
	 */
	@Test
	public void testGetSubjsOnPred() {
		Assert.assertEquals(1, this.helper.getSubjsOnPred(JenaResourceHelperExtendedTest.PREDICATENSAP).size());
		try {
			this.helper.getSubjsOnPred(null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
	}


	/**
	 * 
	 */
	@Test
	public void testGetSubjsOnPredLit() {
		Assert.assertEquals(1, this.helper.getSubjsOnPredLit(JenaResourceHelperExtendedTest.VCARDFNAME, "John Smith").size());
		try {
			this.helper.getSubjsOnPredLit(null, "John Smith");
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.getSubjsOnPredLit(JenaResourceHelperExtendedTest.VCARDFNAME, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.getSubjsOnPredLit(null, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
	}


	/**
	 * 
	 */
	@Test
	public void testGetSubjsOnPredRes() {
		Assert.assertEquals(1, this.helper.getSubjsOnPredRes(JenaResourceHelperExtendedTest.PREDICATENSAP, "http://somewhere/else#x").size());
		try {
			this.helper.getSubjsOnPredRes(null, "John Smith");
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.getSubjsOnPredRes(JenaResourceHelperExtendedTest.VCARDFNAME, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
		try {
			this.helper.getSubjsOnPredRes(null, null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
	}


	/**
	 * 
	 */
	@Test
	public void testIsDefinedresource() {
		Assert.assertTrue(this.helper.isDefinedResource(JenaResourceHelperExtendedTest.SUBJ));
		Assert.assertFalse(this.helper.isDefinedResource(JenaResourceHelperExtendedTest.SUBJ + "22"));
		try {
			this.helper.isDefinedResource(null);
			Assert.fail();
		} catch (final RDFHelperException e) {
			Assert.assertTrue(true);
		}
	}
}
